"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .bucketschema_output import BucketSchemaOutput, BucketSchemaOutputTypedDict
from mixpeek.types import BaseModel, Nullable, OptionalNullable, UNSET, UNSET_SENTINEL
from pydantic import model_serializer
from typing import Optional
from typing_extensions import NotRequired, TypedDict


class BucketResponseMetadataTypedDict(TypedDict):
    r"""Additional metadata for the bucket"""


class BucketResponseMetadata(BaseModel):
    r"""Additional metadata for the bucket"""


class BucketResponseTypedDict(TypedDict):
    r"""Response model for bucket operations"""

    bucket_name: str
    r"""Human-readable name for the bucket"""
    bucket_schema: BucketSchemaOutputTypedDict
    r"""Schema definition for bucket objects"""
    object_count: int
    r"""Number of objects in the bucket"""
    total_size_bytes: int
    r"""Total size of all objects in the bucket in bytes"""
    bucket_id: NotRequired[str]
    r"""Unique identifier for the bucket"""
    description: NotRequired[Nullable[str]]
    r"""Description of the bucket"""
    metadata: NotRequired[BucketResponseMetadataTypedDict]
    r"""Additional metadata for the bucket"""


class BucketResponse(BaseModel):
    r"""Response model for bucket operations"""

    bucket_name: str
    r"""Human-readable name for the bucket"""

    bucket_schema: BucketSchemaOutput
    r"""Schema definition for bucket objects"""

    object_count: int
    r"""Number of objects in the bucket"""

    total_size_bytes: int
    r"""Total size of all objects in the bucket in bytes"""

    bucket_id: Optional[str] = None
    r"""Unique identifier for the bucket"""

    description: OptionalNullable[str] = UNSET
    r"""Description of the bucket"""

    metadata: Optional[BucketResponseMetadata] = None
    r"""Additional metadata for the bucket"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["bucket_id", "description", "metadata"]
        nullable_fields = ["description"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
