"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from mixpeek.types import BaseModel, Nullable, OptionalNullable, UNSET, UNSET_SENTINEL
from pydantic import model_serializer
from typing_extensions import NotRequired, TypedDict


class InputsTypedDict(TypedDict):
    pass


class Inputs(BaseModel):
    pass


class RetrieverBindingTypedDict(TypedDict):
    r"""How a retriever should be used in a taxonomy"""

    retriever_id: str
    r"""ID of the retriever to use"""
    inputs: NotRequired[Nullable[InputsTypedDict]]
    r"""Optional inputs to the retriever. If not provided, will use source collection schema"""


class RetrieverBinding(BaseModel):
    r"""How a retriever should be used in a taxonomy"""

    retriever_id: str
    r"""ID of the retriever to use"""

    inputs: OptionalNullable[Inputs] = UNSET
    r"""Optional inputs to the retriever. If not provided, will use source collection schema"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["inputs"]
        nullable_fields = ["inputs"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
